import std.process;
import std.file;
import std.conv;
import std.format;
import std.typecons;
import glue;

bool hasWon(ubyte[5][5] grid, ubyte[] called)
{
    if (!"pad".exists)
    {
        executeShell("zig build-exe r13.zig --library c --library z && ./r13 -c pad.b pad");
    }

    // :)
    std.file.write(".input", to!string(grid));
    auto output = executeShell("cat .input | ./r13 -r pad").output;

    bool[25] bools;
    foreach (n; called)
    {
        auto index = glueCall!(Nullable!size_t)("r8.hs", format(`entry "%02d" "%s"`, n, output));
        if (!index.isNull)
        {
            bools[index.get()/3] = true; 
        }
    }

    return glueCall!bool("is_line.zig", format("isLine(%s)", passSliceToZig(bools, ".")));
}
